#
# spec file for package blktrace (Version 1.0.0)
#
# Copyright (c) 2009 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild

%{!?_without_docs: %global with_docs 1}

Name:           blktrace
Summary:        Block IO tracer
License:        GPL v2 only
Group:          Development/Tools/Other
Version:        1.0.0
Release:        2.7.12
Url:            http://git.kernel.dk/?p=blktrace.git;a=summary
Source0:        %name-%version.tar.bz2
Patch0:         missing-abort-request-bad-fs-action-40010011.patch
Patch1:         blkparse-track-smallest-sequence-read-per-device.patch
Patch2:         0001-Moved-btrecord-btreplay-to-version-1.0.0.patch
Patch3:         0002-Added-in-z-to-provide-running-waiting-for-issue-lat.patch
Patch4:         0003--Fixed-segfault-in-aqd.c-need-to-check-for-NULL-n.patch
Patch5:         0004-Fixed-M-displays-on-per-io-output-and-added-in-I-O.patch
Patch6:         0005-Added-P-to-create-a-data-file-w-Q-D-and-C-per-lin.patch
Patch7:         0006-gcc-4.3.2-has-started-to-warn-about.patch
Patch8:         0007-Added-no-messages-option-to-blkparse.c.patch
Patch9:         0009-A-couple-of-min-counters-weren-t-initialised-correct.patch
Patch10:        0001-Blktrace-failed-to-lock-reader-threads-on-the-cpu-us.patch
Patch11:        0001-handle-race-to-mkdir-at-startup.patch
Patch12:        0002-fix-include-statement-in-stats.h.patch
Patch13:        0003-fix-off-by-one-issues-in-blkiomon.h.patch
Patch14:        0004-blkiomon-fix-unaligned-accesses-on-ia64.patch
# Patches from Factory
Patch100:       0001-Update-q_iop-c_time-in-handle_queue.patch
Patch101:       blktrace-explicit-enum.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  gcc libaio-devel
%if 0%{?with_docs}
%if 0%{?suse_version} >= 1030
BuildRequires:  texlive texlive-latex
%else
BuildRequires:  te_latex tetex
# The libpng requires is ignored if it comes from tetex
BuildRequires:  libpng
%endif
%endif

%description
blktrace is a block layer IO tracing mechanism which provides detailed
information about request queue operations up to user space. This is
valuable for diagnosing and fixing performance or application problems
relating to block layer io.



Authors:
--------
    Jens Axboe <axboe@kernel.dk>
    Alan D. Brunelle <Alan.Brunelle@hp.com>
    Nathan Scott <nathans@sgi.com>

%prep
%setup -q
%patch101 -p1
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch100 -p1

%build
make CFLAGS="$RPM_OPT_FLAGS" all %{?with_docs: docs}

%install
make DESTDIR=$RPM_BUILD_ROOT prefix=%{_prefix} mandir=%{_mandir} install
# move blktrace to /bin (bug #300186)
mkdir -p $RPM_BUILD_ROOT/bin
mv $RPM_BUILD_ROOT%{_prefix}/bin/{blktrace,blkparse,btrace} \
    $RPM_BUILD_ROOT/bin

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc README %{?with_docs: doc/blktrace.pdf btreplay/doc/btreplay.pdf btt/doc/btt.pdf}
/bin/blktrace
/bin/blkparse
/bin/btrace
%{_prefix}/bin/blkrawverify
%{_prefix}/bin/bno_plot.py
%{_prefix}/bin/btt
%{_prefix}/bin/btrecord
%{_prefix}/bin/btreplay
%{_prefix}/bin/verify_blkparse
%{_prefix}/bin/blkiomon
%{_mandir}/man1/blkparse.1*
%{_mandir}/man1/blkrawverify.1*
%{_mandir}/man1/bno_plot.1*
%{_mandir}/man1/btt.1*
%{_mandir}/man1/verify_blkparse.1*
%{_mandir}/man8/blktrace.8*
%{_mandir}/man8/btrace.8*
%{_mandir}/man8/btrecord.8*
%{_mandir}/man8/btreplay.8*
%{_mandir}/man8/blkiomon.8*

%changelog
* Fri Aug  7 2009 jblunck@suse.de
- Statically define enums (bnc #524978).
* Tue Jun 16 2009 jblunck@suse.de
- Fix typo in btt (bnc #511264).
* Tue Jun 16 2009 jblunck@suse.de
- Add btt documentation.
* Fri May 29 2009 jblunck@suse.de
- Update for SLES10-SP3:
  * Moved btrecord/btreplay to version 1.0.0
  * Added in -z to provide running waiting-for-issue latencies
  * Fixed segfault in aqd.c : need to check for NULL (not requested)
  * Fixed 'M' displays on per-io output and added in I/O separator
  * Added -P to create a data file w/ Q, D and C per line
  * gcc 4.3.2 has started to warn about:
  * Added no messages option to blkparse.c
  * A couple of min-counters weren't initialised correctly
  * Blktrace failed to lock reader threads
  * handle race to mkdir at startup
  * fix include statement in stats.h
  * fix off-by-one issues in blkiomon.h
  * blkiomon: fix unaligned accesses on ia64 (blkiomon version 0.3)
* Tue Dec  9 2008 jblunck@suse.de
- blkparse: Track smallest sequence read per device
* Mon Dec  8 2008 jblunck@suse.de
- Fix for "Bad fs action 40010011" messages (bnc #450909).
* Tue Nov  4 2008 jblunck@suse.de
- Update to version 1.0.0:
  * Update rbtree to version with unified parent + color
  * blkiomon: add through-put statistics
  * blkiomon: separate statistics for read and write requests
  * blkiomon: fix some debug messages
  * blkiomon: fix trace debug output
  * blkiomon: fix unit in histogram output
  * blkiomon: fix cross-arch data analysis issue
  * blkiomon: drv_data traces pass-through
  * blkparse: add hint for discarded drv_data traces
  * Added in -L option - output periodic latency information
  * Added in -Q / --active-queue-depth option
  * Add driver data support
  * blktrace: accept -v (lower case) for version info as well
  * blkiomon: I/O monitor
  * Removed excessive amounts of seek modes (for random sets of I/Os)
  * spec file tweak
  * man page typo
  * Added in %%done for btt
  * Add documentation of 'D' discard operation
  * blktrace: support discard requests
  * spelling and grammar fixes for btreplay.tex
  * Put message notes from kernel into a separate file for easy tracking
  * Added in new message updates to the documentation.
  * Added in handling of MESSAGE notes
  * Handled no difference in seek times
  * Added in -m option, seeks-per-second
  * blkparse: cope with missing process notify event
  * Fixed percentage calculations for phases of an I/O
  * Added S2G times + fixed up -X output to include X2X
  * Added -X option - generate easily parseable file
  * Add -x accellerator option
  * Fix problem with -w option
  * eliminate check of empty -F format
  * blkparse: Introduce optional accounting of PC requests
  * blkparse: Add PC requests to depth trace
  * Fix section of btrecord and btreplay man pages
  * Don't like btrecord against libaio and librt, as it doesn't use any of
    their symbols
  * Really commit the changes to btt.1
  * Added man page for bno_plot and updated btt man page to refer to bno_plot
  * Cleanups: Fixed IOPs in btt left over at end of run
  * btt: fix missing cleanup call
  * btt: fix iostat interval default
  * Added info about bno_plot.py and clean ups
  * Added new IOs per unplug table
  * Added bno_plot.py - generate interactive 3D plot of IO blocks and sizes
* Fri Oct 24 2008 jblunck@suse.de
- Add two additional patches for my friend Gerald (bnc #433433):
  * blkparse: Introduce optional accounting of PC requests
  * blkparse: Add PC requests to depth trace
* Mon Sep 15 2008 jjolly@suse.de
- Added blkiomon and manpage to specfile
* Fri Sep 12 2008 jjolly@suse.de
- Added patches for FCP performance data collection (bnc#417241)
* Mon May 19 2008 jblunck@suse.de
- cope with missing process notify event which could otherwise segfault
* Fri Feb  1 2008 jblunck@suse.de
- Update to commit 00a47cd169f2cc87b5f63fe93226b7231dee678c
  * Fixed excess bucket information for unplug histograms
  * UNPLUG does the timing stuff, UNPLUG TIMEOUT only does timeout
* Tue Jan 22 2008 jblunck@suse.de
- Update to commit 461afe819c41fa811f9c6264524cb8edbd2acc63:
  * Fix Q counts during requeue and merges
  * Separated out g/i/m trace handling
  * btreplay/btrecord man pages
  * Remove strange make dependency
  * Added in Q2D histograms (requires -A)
  * memset() must be done after NULL check
  * Added active requests at Q information
  * Fixed REMAP to update Q2A & fixed #Q calculations
  * blktrace segfault
  * Added O_NOATIME to replay file
  * Fix segfault in replay_sub when verbose is 1
  * Converted fatal to an inline function
  * Converted fatal from macro to inline
  * Add btrecord/btreplay capability
  * Added list_splice to btt/list.h
  * btt manpages
  * Fix compilation on m68k
  * Major revamping (ver 2.0)
* Wed Aug 29 2007 jblunck@suse.de
- Update to 0.99.3:
  * fix indent typo
  * man page: mention buffer size / number of buffers defaults
  * Makefile fixes
* Sun Aug 26 2007 jblunck@suse.de
- Initial openSUSE package
* Mon Oct 10 2005 axboe@suse.de
- Initial version
